$(document).ready(function() {

    //Nested list
    function clean(object) {
        Object
            .entries(object || {})
            .forEach(([k, v]) => {
                if (v && typeof v === 'object') {
                    clean(v);
                }
                if (v && typeof v === 'object' && !Object.keys(v).length /* || v === null */ || v === undefined) {
                    if (Array.isArray(object)) {
                        object.splice(k, 1);
                    } else {
                        delete object[k];
                    }
                }
            });
        return object;
    }

    $('#nestable').nestable({
        group: 1,
        json: clean(json),
        contentCallback: function(item) {
            var content = item.title || '' ? item.title : item.id;
            content += item.parent_id || '' ? ' ' : ' <small>'+trans.mainCategory+'</small>';
            // content += ' <i>(id = ' + item.id + ')</i>';
            // content += ' <u>(parent_id = ' + item.parent_id + ')</u>';
            return content;
        },
        callback: function(l,e){
            $.ajax({
                url: route.post,
                method: 'post',
                data: {
                    data:l.nestable('toArray'),
                    _token: $('meta[name="csrf-token"]').attr('content')
                },
                success: function(result){
                    Vue.prototype.$notify({
                        title: result.title,
                        text: result.message,
                        type: 'success'
                    })
                },
                error: function(result){
                    Vue.prototype.$notify({
                        title: result.status+' '+result.statusText,
                        text: result.responseJSON.message,
                        type: 'error'
                    })
                }
            });
        }
    });

    $('#nestableForMenu').nestable({
        group: 1,
        json: clean(json),
        contentCallback: function(item) {
            var content = item.name || '' ? item.name : item.id;
            content += item.parent_id || '' ? ' ' : ' <small>'+trans.mainCategory+'</small>';
            if (isCanEdit) {
                content += ' <a href="'+route.menu+'/items/'+item.id+'/edit" class="menu-item-edit dd-nodrag"><i class="fa fa-pencil"></i></a>';
            }
            // content += ' <u>(parent_id = ' + item.parent_id + ')</u>';
            return content;
        },
        callback: function(l,e){
            $.ajax({
                url: route.post,
                method: 'post',
                data: {
                    data:l.nestable('toArray'),
                    _token: $('meta[name="csrf-token"]').attr('content')
                },
                success: function(result){
                    Vue.prototype.$notify({
                        title: result.title,
                        text: result.message,
                        type: 'success'
                    })
                },
                error: function(result){
                    Vue.prototype.$notify({
                        title: result.status+' '+result.statusText,
                        text: result.responseJSON.message,
                        type: 'error'
                    })
                }
            });
        }
    });

    //Nested List Buttons/Menu
    $('#nestable-menu').on('click', function(e) {
        var target = $(e.target),
            action = target.data('action');
        if(action === 'expand-all') {
            $('.dd').nestable('expandAll');
        }
        if(action === 'collapse-all') {
            $('.dd').nestable('collapseAll');
        }
        // if(action === 'add-item') {
        // 	var newItem = {
        // 		"id": ++lastId,
        // 		"content": "New Item " + lastId,
        // 		"parent_id":2
        // 	};
        // 	$('#nestable').nestable('add', newItem);
        // }
        // if(action === 'replace-item') {
        // 	var replacedItem = {
        // 		"id": 10,
        // 		"content": "New item 10",
        // 		"children": [
        // 			{
        // 				"id": ++lastId,
        // 				"content": "Item " + lastId,
        // 				"children": [
        // 					{
        // 						"id": ++lastId,
        // 						"content": "Item " + lastId
        // 					}
        // 				]
        // 			}
        // 		]
        // 	};
        // 	$('#nestable').nestable('replace', replacedItem);
        // }
    });

});