$(document).ready(function () {
  "use strict";

  //Problem Fix. "Added non-passive event listener to a scroll-blocking 'touchX' evenet."
  jQuery.event.special.touchstart = {
    setup: function( _, ns, handle ){
      if ( ns.includes("noPreventDefault") ) {
        this.addEventListener("touchstart", handle, { passive: false });
      } else {
        this.addEventListener("touchstart", handle, { passive: true });
      }
    }
  };
  jQuery.event.special.touchmove = {
    setup: function( _, ns, handle ){
      if ( ns.includes("noPreventDefault") ) {
        this.addEventListener("touchmove", handle, { passive: false });
      } else {
        this.addEventListener("touchmove", handle, { passive: true });
      }
    }
  };

  //Fix 2.
  (function () {
    if (typeof EventTarget !== 'undefined') {
      let supportsPassive = false;
      try {
        // Test via a getter in the options object to see if the passive property is accessed
        const opts = Object.defineProperty({}, 'passive', {
          get: () => {
            supportsPassive = true;
          },
        });
        window.addEventListener('testPassive', null, opts);
        window.removeEventListener('testPassive', null, opts);
      } catch (e) {}
      const func = EventTarget.prototype.addEventListener;
      EventTarget.prototype.addEventListener = function (type, fn) {
        this.func = func;
        this.func(type, fn, supportsPassive ? { passive: false } : false);
      };
    }
  })();

  // ======= footer now year
  document.getElementById("year").innerHTML = new Date().getFullYear();

  // ======= Sticky
  window.onscroll = function () {
    const ud_header = document.querySelector(".ud-header");
    const sticky = ud_header.offsetTop;
    const logo = document.querySelector(".navbar-brand img");
    // const logo = document.querySelector(".navbar-brand embed");

    if (window.pageYOffset > sticky) {
      ud_header.classList.add("sticky");
    } else {
      ud_header.classList.remove("sticky");
    }

    // === logo change
    if (ud_header.classList.contains("sticky")) {
      // logo.src = "assets/images/logo/logo-full-blue.png";
      if (logo.src !== colored){
        logo.src = colored;
      }

    } else {
      if (logo.src !== negative) {
        logo.src = negative;
      }
    }

    // show or hide the back-top-top button
    const backToTop = document.querySelector(".back-to-top");
    if (
      document.body.scrollTop > 50 ||
      document.documentElement.scrollTop > 50
    ) {
      backToTop.style.display = "flex";
    } else {
      backToTop.style.display = "none";
    }
  };

  //===== close navbar-collapse when a  clicked
  let navbarToggler = document.querySelector(".navbar-toggler");
  const navbarCollapse = document.querySelector(".navbar-collapse");

  document.querySelectorAll(".ud-menu-scroll").forEach((e) =>
    e.addEventListener("click", () => {
      navbarToggler.classList.remove("active");
      navbarCollapse.classList.remove("show");
    })
  );
  navbarToggler.addEventListener("click", function () {
    navbarToggler.classList.toggle("active");
    navbarCollapse.classList.toggle("show");
  });

  // ===== submenu

  /*SmarTeknoloji responsive screen active class problem fix ==start */
  const debounce = (func, wait, immediate) => {
    var timeout;
    return () => {
      const context = this, args = arguments;
      const later = function() {
        timeout = null;
        if (!immediate) func.apply(context, args);
      };
      const callNow = immediate && !timeout;
      clearTimeout(timeout);
      timeout = setTimeout(later, wait);
      if (callNow) func.apply(context, args);
    };
  };
  /*SmarTeknoloji responsive screen active class problem fix ==after-step */

  const submenuButton = document.querySelectorAll(".nav-item-has-children");
  submenuButton.forEach((elem) => {
    elem.querySelector("a").addEventListener("click", () => {
      elem.classList.toggle("st-before-v-nav-child"); //smartek.added.311021
      elem.querySelector(".ud-submenu").classList.toggle("show");

      if ($(".navbar-collapse").css("display") === "block") { //smartek.added.311021
        // console.log("mobile nav submenu opened");
        elem.querySelector("a").classList.toggle("active"); //smartek.added.311021
      }

      /*SmarTeknoloji responsive screen active class problem fix ==next */
      window.addEventListener('resize', debounce(() =>{
        console.log('This site is responsive! Developed by SmarTeknoloji <3');
        elem.querySelector("a").classList.toggle("active",false);
        elem.querySelector(".ud-submenu").classList.toggle("show",false);
        elem.classList.toggle("st-before-v-nav-child",false);
      }, 200, false), false);
      /*SmarTeknoloji responsive screen active class problem fix ==end */

      // console.log("menu acildi");
    });
  });

  /* ### Menu Active Func. -beta ### */
  // $(function($) {
  //   let url = window.location.href;
  //   $('ul li a').each(function() {
  //     if (this.href === url) {
  //       $(this).closest('li').addClass('active');
  //       $(this).addClass('active');
  //     }
  //   });
  // });

  // ===== wow js
  new WOW().init();

  // ====== scroll top js
  function scrollTo(element, to = 0, duration = 500) {
    const start = element.scrollTop;
    const change = to - start;
    const increment = 20;
    let currentTime = 0;

    const animateScroll = () => {
      currentTime += increment;

      const val = Math.easeInOutQuad(currentTime, start, change, duration);

      element.scrollTop = val;

      if (currentTime < duration) {
        setTimeout(animateScroll, increment);
      }
    };

    animateScroll();
  }

  Math.easeInOutQuad = function (t, b, c, d) {
    t /= d / 2;
    if (t < 1) return (c / 2) * t * t + b;
    t--;
    return (-c / 2) * (t * (t - 2) - 1) + b;
  };

  document.querySelector(".back-to-top").onclick = () => {
    scrollTo(document.documentElement);
  };

  // ======= Right Side Bar Menu
  $('.bar_menu,#nav-icon1').on('click',function(){
    if( $(".right_sidebar_menu").hasClass('open') ){
      $(".right_sidebar_menu").removeClass('open');
    }
    else{
      $(".right_sidebar_menu").addClass('open');
    }
    return false
  });

  $('body').click(function (event) //smartek.solution.fixed.041121
  {
    if(!$(event.target).closest('.right_sidebar_menu').length && !$(event.target).is('.right_sidebar_menu')) {
      $(".right_sidebar_menu").removeClass('open');
    }
  });

});

/* ### Sidebar Menu ### */
$(function () {
  var list = document.querySelectorAll('.list');

  function accordion(e) {
    e.stopPropagation();
    if (this.classList.contains('active')) {
      this.classList.remove('active');
    } else
    if (this.parentElement.parentElement.classList.contains('active')) {
      this.classList.add('active');
    } else
    {
      for (i = 0; i < list.length; i++) {
        list[i].classList.remove('active');

      }
      this.classList.add('active');
    }
  }
  for (i = 0; i < list.length; i++) {
    list[i].addEventListener('click', accordion);
  }

  $('li.list').addClass(function(idx, className) {
    if ($(this).find('.visited').length > 0) {
      return 'active';
    }
  });

});
